Follow me picking the wrong side of a face


#1

I am trying to create various size domes shapes using the api. I am running into a problem where some domes look correct (white color) while other domes are incorrect (grey color). It seems that SketchUp is not consistent on which side of the face to use in the follow me. Is there something I can do to always get the same results?

Please see the attached screen shot and ruby script.
trmb_Dome.rb (2.4 KB)


#2

There are several reasons why the extrusion might get made inside out. Things like not being consistent in the direction you draw the path, which end of the path you put the profile on and the orientation of the profile face all have an impact. SketchUp is being consistent but what you’ve drawn generally isn’t. It happens but it’s easily fixed with a Context click and Reverse Faces and probably not worth losing sleep over.


#3

I agree with all that you are saying but I am using the same code, so both domes are create exactly in the same way. One is correct an the other is not.


#4

your using negative values in the first and none in the second, which is giving you different windings…

make both at origin or both at 10 and they will have the same winding…

john


#5

One can comment out the method call to FollowMe and manually perform a follow me and observe the same results. (In that manual operation, the middle circle isn’t removed like the method does).
Unlike the second dome, the first one’s concave inside has a hole, so it can’t be a solid. I tried a double sized first dome and that prevented missing faces (there are some sort of limits to arc curves at small dimensions).

I commented out the second dome statements and played around with the first dome with the edits below:

. . .
scale = 2.0

center = ORIGIN
xaxis  = Y_AXIS     # confusing name here
normal = Z_AXIS

edges  = AddArc(center, xaxis, normal, scale * 0.42)
edges += AddArc(center, xaxis, normal, scale * 0.232)

arcOuterStartPoint = Geom::Point3d.new( scale * -0.42,  0,  0 )
arcOuterEndPoint   = Geom::Point3d.new( 0,   scale * 0.42,  0 )
arcInnerStartPoint = Geom::Point3d.new( scale * -0.232, 0,  0 )
arcInnerEndPoint   = Geom::Point3d.new( 0,   scale * 0.232, 0 )
. . .
diameter = scale * 0.652
. . .

The variable “scale” allows scale changes by modifying it and reloading. At a scale of 2 the hole is gone. I am seeing the problem come and go depending on the scale factor with the Windows version:

On Windows 7, with both SU 2015 and SU 2016 Make, I see white (default face front material) at a scale of 4.9, and gray (face back material) at a scale of 5.

On Mac OS X with SU 2015 Make, I tried different scale factors, and one test with scale at a value of 10 I think I saw the gray side, but then I spent some time trying to duplicate it and I couldn’t.


#6

Thanks Bruce. I’ll play with the scaling a little more. We had tried using a scale of 100 because we were seeing similar issues with the follow me on smaller dimensions as you noted. I was just trying to find a pattern so that I could apply something consistently on all sizes of the dome.